<?php
/* --------------------------------------------------------------
   OvistoLogoService.inc.php 2018-01-29
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2018 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * Class OvistoLogoService
 */
class OvistoLogoService
{
    /**
     * @var OvistoLogoStorageReader $logoStorageReader
     */
    protected $logoStorageReader;
    
    
    /**
     * OvistoLogoService constructor.
     *
     * @param OvistoLogoStorageReader $logoStorageReader
     */
    public function __construct(OvistoLogoStorageReader $logoStorageReader)
    {
        $this->logoStorageReader = $logoStorageReader;
    }
    
    
    /**
     * Gets the requested logo.
     * 
     * @param StringType $logoUrl
     *
     * @return OvistoLogo
     */
    public function getLogo(StringType $logoUrl)
    {
        return $this->logoStorageReader->getLogo($logoUrl);
    }
}